##
##  sasl.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         sasl
Summary:      Simple Authentication and Security Layer
URL:          http://asg.web.cmu.edu/sasl/
Vendor:       Cyrus Project, CMU
Packager:     The OpenPKG Project
Distribution: OpenPKG [PLUS]
Group:        Cryptography
License:      BSD
Version:      2.1.10
Release:      20030103

#   package options
%option       with_fsl    no
%option       with_pam    no

#   list of sources
Source0:      ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/cyrus-sasl-%{version}.tar.gz
Source1:      rc.sasl
Source2:      fsl.sasl

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20030103, db >= 4.1.24, openssl, gcc
PreReq:       OpenPKG, openpkg >= 20030103
%if "%{with_fsl}" == "yes"
BuildPreReq:  fsl
PreReq:       fsl
%endif
%if "%{with_pam}" == "yes"
BuildPreReq:  PAM
PreReq:       PAM
%endif
AutoReq:      no
AutoReqProv:  no

%description
    SASL is the Simple Authentication and Security Layer, a method
    for adding authentication support to connection-based protocols.
    To use SASL, a protocol includes a command for identifying and
    authenticating a user to a server and for optionally negotiating
    protection of subsequent protocol interactions. If its use is
    negotiated, a security layer is inserted between the protocol and
    the connection.

%prep
    %setup -q -n cyrus-sasl-%{version}
    %{l_shtool} subst \
        -e 's;^ *for dbname in ;for dbname in db ;' \
        configure

%build
    %{l_shtool} subst \
        -e "s;javac;javac-xxx;g" \
        -e "s;javah;javah-xxx;g" \
        -e "s;javadoc;javadoc-xxx;g" \
        configure
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O} %{l_cppflags}" \
%if "%{with_fsl}" == "yes"
    LDFLAGS="%{l_ldflags} `%{l_prefix}/bin/fsl-config --all --ldflags`" \
    LIBS="-ldb `%{l_prefix}/bin/fsl-config --all --libs`" \
%else
    LDFLAGS="%{l_ldflags}" \
    LIBS="-ldb" \
%endif
    ./configure \
        --prefix=%{l_prefix} \
        --with-plugindir=%{l_prefix}/lib/sasl \
        --with-saslauthd=%{l_prefix}/var/sasl/saslauthd \
        --with-dbpath=%{l_prefix}/var/sasl/sasldb \
        --with-dblib=berkeley \
        --with-bdb-incdir=%{l_prefix}/include \
        --with-bdb-libdir=%{l_prefix}/lib \
%if "%{with_pam}" == "yes"
        --with-pam \
%else
        --without-pam \
%endif
        --disable-shared \
        --enable-static \
        --disable-java \
        --disable-sample \
        --disable-krb4 \
        --disable-gssapi \
        --disable-otp \
        --without-des \
        --without-opie
    %{l_make} %{l_mflags}

%install
    rm -rf $RPM_BUILD_ROOT
    %{l_make} %{l_mflags} install AM_MAKEFLAGS="DESTDIR=$RPM_BUILD_ROOT"
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 \
        -e 's;@l_prefix@;%{l_prefix};g' \
%if "%{with_pam}" == "yes"
        -e 's;@authmech@;pam;g' \
%else
        -e 's;@authmech@;getpwent;g' \
%endif
        %{SOURCE rc.sasl} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/
%if "%{with_fsl}" == "yes"
      %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/fsl
      %{l_shtool} install -c -m 644 \
          -e 's;@l_prefix@;%{l_prefix};g' \
          %{SOURCE fsl.sasl} \
          $RPM_BUILD_ROOT%{l_prefix}/etc/fsl/
%endif
    %{l_shtool} mkdir -f -p -m 700 \
        $RPM_BUILD_ROOT%{l_prefix}/var/sasl/log
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/var/sasl/saslauthd
    mv $RPM_BUILD_ROOT%{l_prefix}/lib/sasl2 \
        $RPM_BUILD_ROOT%{l_prefix}/lib/sasl
    strip $RPM_BUILD_ROOT%{l_prefix}/sbin/* >/dev/null 2>&1 || true
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std} \
%if "%{with_fsl}" == "yes"
        '%config %{l_prefix}/etc/fsl/fsl.sasl' \
        '%not %dir %{l_prefix}/etc/fsl' \
%endif
        '%dir %attr(-,%{l_susr},%{l_sgrp}) %{l_prefix}/var/sasl/log'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

